/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.gui.nomenclatures;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.common.modele.nomenclatures.carriere.EOTypePopulation;
import org.cocktail.mangue.common.modele.nomenclatures.emploi.EOCategorieEmploi;
import org.cocktail.mangue.common.modele.nomenclatures.emploi.EOCorpsCategEmploi;
import org.cocktail.mangue.common.utilities.CocktailConstantes;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.mangue.modele.grhum.EOCorps;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class NomenclatureCatEmploiView extends javax.swing.JPanel {


	private static final long serialVersionUID = -7770031412248058797L;

	protected EODisplayGroup eodCorps, eodCategorie;
	protected ZEOTable myEOTableCorps, myEOTableCategorie;
	protected ZEOTableModel myTableModelCorps, myTableModelCategorie;
	protected TableSorter myTableSorterCorps, myTableSorterCategorie;

    /** Creates new form TemplateJPanel */
    public NomenclatureCatEmploiView(EODisplayGroup eodCategorie, EODisplayGroup eodCorps) {

        this.eodCorps = eodCorps;
        this.eodCategorie = eodCategorie;
        
        initComponents();
        initGui();
        
    }

	/** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTableCategories = new javax.swing.JPanel();
        viewTableCorps = new javax.swing.JPanel();
        btnAjouterCorps = new javax.swing.JButton();
        btnSupprimeCorps = new javax.swing.JButton();
        btnAjouterCategorie = new javax.swing.JButton();
        btnModifierCategorie = new javax.swing.JButton();
        btnSupprimerCategorie = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        tfFiltreLibelleCategorie = new javax.swing.JTextField();

        viewTableCategories.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableCategories.setLayout(new java.awt.BorderLayout());

        viewTableCorps.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableCorps.setLayout(new java.awt.BorderLayout());

        btnAjouterCorps.setToolTipText("Ajouter une équivalence grade");

        btnSupprimeCorps.setToolTipText("Supprimer l'équivalence");

        btnAjouterCategorie.setToolTipText("Ajouter une équivalence corps");

        btnModifierCategorie.setToolTipText("Modifier l'équivalence");

        btnSupprimerCategorie.setToolTipText("Supprimer l'équivalence");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("Code / Libellé ?");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 94, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(tfFiltreLibelleCategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 148, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 76, Short.MAX_VALUE)
                        .add(btnAjouterCategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnModifierCategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSupprimerCategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, viewTableCategories, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 408, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(btnAjouterCorps, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSupprimeCorps, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(viewTableCorps, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 520, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                .add(jLabel2)
                                .add(tfFiltreLibelleCategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(btnAjouterCategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(btnModifierCategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(btnSupprimerCategorie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewTableCategories, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 670, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(btnSupprimeCorps, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnAjouterCorps, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewTableCorps, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 674, Short.MAX_VALUE)))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JButton btnAjouterCategorie;
    protected javax.swing.JButton btnAjouterCorps;
    protected javax.swing.JButton btnModifierCategorie;
    protected javax.swing.JButton btnSupprimeCorps;
    protected javax.swing.JButton btnSupprimerCategorie;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField tfFiltreLibelleCategorie;
    protected javax.swing.JPanel viewTableCategories;
    protected javax.swing.JPanel viewTableCorps;
    // End of variables declaration//GEN-END:variables

        private void initGui() {

    	btnAjouterCategorie.setIcon(CocktailIcones.ICON_ADD);
    	btnModifierCategorie.setIcon(CocktailIcones.ICON_UPDATE);
    	btnSupprimerCategorie.setIcon(CocktailIcones.ICON_DELETE);

    	btnAjouterCorps.setIcon(CocktailIcones.ICON_ADD);
    	btnSupprimeCorps.setIcon(CocktailIcones.ICON_DELETE);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eodCategorie, EOCategorieEmploi.C_CATEGORIE_EMPLOI_KEY, "Code", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eodCategorie, EOCategorieEmploi.LL_CATEGORIE_EMPLOI_KEY, "Libellé", 250);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);

		myTableModelCategorie = new ZEOTableModel(eodCategorie, myCols);
		myTableSorterCategorie = new TableSorter(myTableModelCategorie);

		myEOTableCategorie = new ZEOTable(myTableSorterCategorie);
		//myEOTable.addListener(myListenerContrat);
		myTableSorterCategorie.setTableHeader(myEOTableCategorie.getTableHeader());		

		myEOTableCategorie.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableCategorie.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableCategorie.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableCategories.setLayout(new BorderLayout());
		viewTableCategories.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableCategories.removeAll();
		viewTableCategories.add(new JScrollPane(myEOTableCategorie), BorderLayout.CENTER);


		myCols = new Vector<ZEOTableModelColumn>();

		col = new ZEOTableModelColumn(eodCorps, EOCorpsCategEmploi.TO_CORPS_KEY+"."+EOCorps.C_CORPS_KEY, "Code", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eodCorps, EOCorpsCategEmploi.TO_CORPS_KEY+"."+EOCorps.LL_CORPS_KEY, "Libellé", 250);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eodCorps, EOCorpsCategEmploi.TO_CORPS_KEY+"."+EOCorps.TO_TYPE_POPULATION_KEY+"."+EOTypePopulation.CODE_KEY, "Pop", 40);
    	col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);

		myTableModelCorps = new ZEOTableModel(eodCorps, myCols);
		myTableSorterCorps = new TableSorter(myTableModelCorps);

		myEOTableCorps = new ZEOTable(myTableSorterCorps);
		//myEOTable.addListener(myListenerContrat);
		myTableSorterCorps.setTableHeader(myEOTableCorps.getTableHeader());		

		myEOTableCorps.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableCorps.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableCorps.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableCorps.setLayout(new BorderLayout());
		viewTableCorps.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableCorps.removeAll();
		viewTableCorps.add(new JScrollPane(myEOTableCorps), BorderLayout.CENTER);

    }

		public ZEOTable getMyEOTableCorps() {
			return myEOTableCorps;
		}

		public void setMyEOTableCorps(ZEOTable myEOTableCorps) {
			this.myEOTableCorps = myEOTableCorps;
		}

		public ZEOTable getMyEOTableCategorie() {
			return myEOTableCategorie;
		}

		public void setMyEOTableCategorie(ZEOTable myEOTableCategorie) {
			this.myEOTableCategorie = myEOTableCategorie;
		}

		public javax.swing.JButton getBtnAjouterCategorie() {
			return btnAjouterCategorie;
		}

		public void setBtnAjouterCategorie(javax.swing.JButton btnAjouterCategorie) {
			this.btnAjouterCategorie = btnAjouterCategorie;
		}

		public javax.swing.JButton getBtnAjouterCorps() {
			return btnAjouterCorps;
		}

		public void setBtnAjouterCorps(javax.swing.JButton btnAjouterCorps) {
			this.btnAjouterCorps = btnAjouterCorps;
		}

		public javax.swing.JButton getBtnModifierCategorie() {
			return btnModifierCategorie;
		}

		public void setBtnModifierCategorie(javax.swing.JButton btnModifierCategorie) {
			this.btnModifierCategorie = btnModifierCategorie;
		}

		public javax.swing.JButton getBtnSupprimeCorps() {
			return btnSupprimeCorps;
		}

		public void setBtnSupprimeCorps(javax.swing.JButton btnSupprimeCorps) {
			this.btnSupprimeCorps = btnSupprimeCorps;
		}

		public javax.swing.JButton getBtnSupprimerCategorie() {
			return btnSupprimerCategorie;
		}

		public void setBtnSupprimerCategorie(javax.swing.JButton btnSupprimerCategorie) {
			this.btnSupprimerCategorie = btnSupprimerCategorie;
		}
		public javax.swing.JTextField getTfFiltreLibelleCategorie() {
			return tfFiltreLibelleCategorie;
		}
		public void setTfFiltreLibelleCategorie(
				javax.swing.JTextField tfFiltreLibelleCategorie) {
			this.tfFiltreLibelleCategorie = tfFiltreLibelleCategorie;
		}
}
